"use strict";
// Copyright (c) 2019 Zekromaster
//
// GNU GENERAL PUBLIC LICENSE
//    Version 3, 29 June 2007
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Various declarations
var fs = require("fs");
var request = require("request");
var rmrf = require("rimraf");
var es6_promisify_1 = require("es6-promisify");
function generateUrl(url) {
    if (url === undefined || url === null)
        return "IGNORE";
    return url;
}
var Mod = /** @class */ (function () {
    // A pretty straightforward constructor
    function Mod(name, version, url, directory) {
        this._name = name;
        this._version = version;
        this._url = generateUrl(url);
        this._directory = directory;
        this._downloadedFlag = false;
    }
    Object.defineProperty(Mod.prototype, "name", {
        // Getters
        get: function () {
            return this._name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mod.prototype, "version", {
        get: function () {
            return this._version;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mod.prototype, "url", {
        get: function () {
            return this._url;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mod.prototype, "directory", {
        get: function () {
            return this._directory;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mod.prototype, "downloadedFlag", {
        // A single setter
        set: function (downloadedFlag) {
            this._downloadedFlag = downloadedFlag;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mod.prototype, "filename", {
        // More complex getters - they expose filename and path
        get: function () {
            return this.name + " [" + this.version + "].jar";
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Mod.prototype, "path", {
        get: function () {
            return this.directory + "/" + this.filename;
        },
        enumerable: true,
        configurable: true
    });
    // This downloads the mod
    Mod.prototype.download = function () {
        return __awaiter(this, void 0, void 0, function () {
            var wsFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // If the mod was already downloaded, nothing happenss
                        if (this._downloadedFlag) {
                            console.log(this.filename + " has already been downloaded. No need to download again.");
                            return [2 /*return*/];
                        }
                        // Checking if the file must be downloaded or not.
                        if (this.url === "IGNORE") {
                            console.log(this.filename + " must be supplied by the user");
                            return [2 /*return*/];
                        }
                        // Executing the download
                        console.log(this.filename + " will be downloaded");
                        wsFile = fs.createWriteStream(this.path);
                        request(this.url).pipe(wsFile);
                        return [4 /*yield*/, new Promise(function (fulfill) { return wsFile.on("finish", fulfill); })];
                    case 1:
                        _a.sent();
                        // Logging the completion of the download
                        console.log(this.filename + " has been downloaded!");
                        return [2 /*return*/];
                }
            });
        });
    };
    return Mod;
}());
function download(jsModlist) {
    return __awaiter(this, void 0, void 0, function () {
        var marrModlist, sModFolder, sarrDirread, _i, _a, mod, _b, marrModlist_1, mod, _loop_1, _c, sarrDirread_1, file, _d, marrModlist_2, mod;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    marrModlist = [];
                    sModFolder = jsModlist.directory;
                    if (!!fs.existsSync(sModFolder)) return [3 /*break*/, 2];
                    return [4 /*yield*/, fs.mkdir(sModFolder, function () {
                            console.log("Created mod folder");
                        })];
                case 1:
                    _e.sent();
                    _e.label = 2;
                case 2: return [4 /*yield*/, es6_promisify_1.promisify(fs.readdir)(sModFolder)];
                case 3:
                    sarrDirread = _e.sent();
                    // This generates an array of "mod" objects
                    for (_i = 0, _a = jsModlist.mods; _i < _a.length; _i++) {
                        mod = _a[_i];
                        marrModlist.push(new Mod(mod.name, mod.version, mod.url, sModFolder));
                    }
                    // Deciding what to download - Iterating over the modlist
                    for (_b = 0, marrModlist_1 = marrModlist; _b < marrModlist_1.length; _b++) {
                        mod = marrModlist_1[_b];
                        mod.downloadedFlag = sarrDirread.includes(mod.filename);
                    }
                    _loop_1 = function (file) {
                        var bIsContained, _i, marrModlist_3, mod;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    bIsContained = false;
                                    // We iterate over the list of mods searching for the [file]
                                    for (_i = 0, marrModlist_3 = marrModlist; _i < marrModlist_3.length; _i++) {
                                        mod = marrModlist_3[_i];
                                        if (file == mod.filename)
                                            bIsContained = true;
                                    }
                                    if (!!bIsContained) return [3 /*break*/, 2];
                                    return [4 /*yield*/, rmrf(sModFolder + "/" + file, function () {
                                            console.log(file + " was removed and thus the file is now deleted.");
                                        })];
                                case 1:
                                    _a.sent();
                                    _a.label = 2;
                                case 2: return [2 /*return*/];
                            }
                        });
                    };
                    _c = 0, sarrDirread_1 = sarrDirread;
                    _e.label = 4;
                case 4:
                    if (!(_c < sarrDirread_1.length)) return [3 /*break*/, 7];
                    file = sarrDirread_1[_c];
                    return [5 /*yield**/, _loop_1(file)];
                case 5:
                    _e.sent();
                    _e.label = 6;
                case 6:
                    _c++;
                    return [3 /*break*/, 4];
                case 7:
                    _d = 0, marrModlist_2 = marrModlist;
                    _e.label = 8;
                case 8:
                    if (!(_d < marrModlist_2.length)) return [3 /*break*/, 11];
                    mod = marrModlist_2[_d];
                    return [4 /*yield*/, mod.download()];
                case 9:
                    _e.sent();
                    _e.label = 10;
                case 10:
                    _d++;
                    return [3 /*break*/, 8];
                case 11:
                    console.log("Remember to use forge " + jsModlist.forgeVersion);
                    return [2 /*return*/];
            }
        });
    });
}
exports.download = download;
